--ForteXorcist v1.976.1 by Xus 21-06-2012 for 4.3.0

if FW.CLASS == "WARLOCK" then
	local FW = FW;
	local WL = FW:ClassModule("Warlock");
	local FWL = FW.L;
	
	local UnitName = FW.FullUnitName;
	
	local CA = FW.Modules.Casting;
	local ST = FW.Modules.Timer;
	local CD = FW.Modules.Cooldown;
	
	FW:RegisterSet("Voidheart Raiment",28963,28968,28966,28967,28964);
	FW:RegisterSet("Vestments of the Faceless Shroud",
	76339,76340,76341,76342,76343,
	78776,78797,78816,78844,78825,
	78681,78702,78721,78749,78730);

	FW:SetCustomName(85768,FWL.DARK_INTENT_BUFF);
	
	if ST then
		local F = ST.F;
		ST:SetDefaultHasted(1)
		
		-- id/name, hastarget, tickspeed
		:AddChannel( 1120,1,3) -- Drain Soul
		:AddChannel(  689,1,1) -- Drain Life
		:AddChannel( 5138,1,1) -- Drain Mana
		:AddChannel( 1949,0,1) -- Hellfire
		:AddChannel( 5740,0,2) -- Rain of Fire
		:AddChannel(79268,0,3) -- Soul Harvest
		
		:AddSpell(85112,   7,"Default",	F.TICKS):SetHasted(0):SetTickSpeed(1) -- Burning Embers
		:AddSpell(  348,  15,"Default",	F.TICKS+F.REFRESH):SetSpellModTlnt(851050,{6}):SetSpellModSetB("Voidheart Raiment",4,3) -- Immolate, refresh by Fel Flame
		:AddSpell(  172,  18,"Default",	F.TICKS+F.REFRESH):SetSpellModSetB("Voidheart Raiment",4,3)-- Corruption, refresh by Life Drain, Drain Soul, Haunt
		:AddSpell(30108,  15,"Default",	F.TICKS+F.REFRESH)-- Unstable Affliction, refresh by Fel Flame

		:AddSpell(80240, 300,"Bane",	F.SHARED+F.UNIQUE) -- Bane of Havoc
		:AddSpell(  980,  24,"Bane",	F.TICKS+F.SHARED):SetTickSpeed(2):SetSpellModGlph(56241,4) -- Bane of Agony
		:AddSpell(  603,  60,"Bane",	F.TICKS+F.SHARED):SetTickSpeed(15) -- Bane of Doom
		
		:AddSpell( 1490, 300,"Curse",	F.SHARED) -- Curse of the Elements
		:AddSpell(  702, 120,"Curse",	F.SHARED) -- Curse of Weakness
		:AddSpell( 1714,  30,"Curse",	F.SHARED):SetDurationPVP(10) -- Curse of Tongues
		:AddSpell(46434,  30,"Curse",	F.SHARED):SetDurationPVP(12) -- Curse of Exhaustion
		
		:AddSpell(  710,  30,"Crowd",	F.UNIQUE):SetDurationPVP(10) -- Banish
		:AddSpell( 5782,  20,"Crowd",	F.UNIQUE):SetDurationPVP(10) -- Fear
		:AddSpell( 5484,   8,"Crowd",	F.AOE) -- Howl of Terror
		
		:AddSpell( 1098, 300,"Pet",		F.CHARM) -- Enslave Demon
		:AddSpell( 1122,  45,"Pet",		F.SUMMON):SetSpellModTlnt(85109,{10,20}):SetSpellModSetB("Vestments of the Faceless Shroud",2,30) -- Infernal
		:AddSpell(18540,  45,"Pet",		F.SUMMON):SetSpellModTlnt(85109,{10,20}):SetSpellModSetB("Vestments of the Faceless Shroud",2,30) -- Doomguard
		:AddSpell( 5697, 600,"Buff",	F.BUFF) -- Unending Breath
		:AddSpell(48181, 000,"Default") -- Haunt (12sec set to 0 for travel time)
		:AddSpell(27243,  18,"Default",	F.TICKS) -- SoC
		:AddSpell(30283,   3,"Crowd",	F.AOE) -- Shadowfury
		
		:AddSpell(47897, 000,"Default",	F.TICKS):SetTickSpeed(2) -- Shadowflame
		:AddSpell(32385, 000,"Default") -- Shadow Embrace
		
		:AddSpell(85768,1800,"Buff",	F.BUFF) -- Dark Intent
		:AddSpell(71521,  15,"Default",	F.NOTARGET) -- Hand of Gul'dan NEED TO LOOK AT THIS
		:AddSpell( 6358,  30,"Pet") -- Seduction
				
		:AddCooldown(17962,010):SetCooldownModGlph(56235,-2) -- Conflag
		:AddCooldown(50796,012) -- Chaos Bolt
		:AddCooldown(48181,008) -- Haunt
		:AddCooldown(71521,012) -- Hand of Gul'dan
		
		--buffname
		:AddBuff(48018) -- Demonic Circle: Summon
		--:AddBuff(37378) -- Shadowflame
		--:AddBuff(37379) -- Flameshadow 
		:AddBuff(17941) -- Shadow Trance
		:AddBuff(51439) -- Backlash
		:AddBuff(47197) -- Eradication
		:AddBuff(61610) -- Metamorphosis
		:AddBuff(47283):SetStacks(0) -- Empowered Imp
		:AddBuff(47383) -- Molten Core
		:AddBuff(63158) -- Decimation
		:AddBuff(54277) -- backdraft
		--:AddBuff(61595) -- demonic soul (t7 bonus)
		--:AddBuff(61082) -- spirits of the damned (t7 bonus)
		:AddBuff(63321) -- glyph of life tap buff
		:AddBuff(70840) -- Devious Minds
		:AddBuff(7812) -- Sacrifice
		
 		:AddBuff(54370) -- Nether Protection (Holy)
		:AddBuff(54371) -- Nether Protection (Fire)
		:AddBuff(54372) -- Nether Protection (Frost)
		:AddBuff(54373) -- Nether Protection (Arcane)
		:AddBuff(54374) -- Nether Protection (Shadow)
		:AddBuff(54375) -- Nether Protection (Nature)
		
		:AddBuff(85383) -- Improved Soul Fire
		:AddBuff(57669) -- Replenishment
		:AddBuff(94310) -- Dark Intent
		:AddBuff(79464) -- Demon Soul
		:AddBuff(79463) -- Demon Soul
		:AddBuff(79462) -- Demon Soul
		:AddBuff(79460) -- Demon Soul
		:AddBuff(79459) -- Demon Soul
		
		:AddBuff(88446) -- Demonic Rebirth
		:AddBuff(89937) -- Fel Spark
		
		:AddBuff(105786) -- Vestments of the Faceless Shroud 4set bonus, Temporal Ruin
		
		-- important debuffs from others i want to track
		:AddDebuff(44836) -- Banish
		:AddDebuff(59669) -- Fear
		:AddDebuff(61191) -- Enslave Demon
		:AddDebuff(17928) -- Howl of Terror
		:AddDebuff(60946) -- Nightmare

		:AddCasterBuffs()

		FW.InstanceDefault.Timer.Filter[FW:SpellName(48018)] = {nil,{-2,0.00,0.67,0.00}}; -- Demonic Circle: Summon
	end
	
	local t1,t2,t3,t4,t5,t6;
	local BP = {};
	
	local bp = FW:SpellName(47982);
	
	local function WL_ScanBloodpact(unit)
		local unitClass = select(2,UnitClass(unit));
		local unitName = UnitName(unit);
		if not unitClass or not unitName then return; end
		t1 = strlower(FW.Settings.BloodPact[1]);
		if strfind(t1,strlower(unitName)) or strfind(t1,strlower(unitClass)) or strfind(t1,"all") or (unit == "player" and strfind(t1,"self")) then
			t2 = UnitBuff(unit,bp);
			if BP[unitName] ~= t2 then
				if FW.Settings.BloodPact[0] then
					if t2 then
						FW:Show(string.format(FWL._GAINED_BLOOD_PACT,unitName),unpack(FW.Settings.BloodpactGainColor));
					else
						FW:Show(string.format(FWL._LOST_BLOOD_PACT,unitName),unpack(FW.Settings.BloodpactLossColor));
					end
				end
				BP[unitName] = t2;
			end
		end
	end
	local PARTY = FW.PARTY;
	local RAID = FW.RAID;
	local function WL_BloodpactScan()
		if GetNumRaidMembers() > 0 then
			for i=1,GetNumRaidMembers(),1 do
				WL_ScanBloodpact(RAID[i]);
			end		
		else
			for i=1,GetNumPartyMembers(),1 do
				WL_ScanBloodpact(PARTY[i]);
			end
			WL_ScanBloodpact("player");
		end
	end
		
	FW:RegisterVariablesEvent(function()
		FW:RegisterTimedEvent("UpdateInterval",		WL_BloodpactScan);
	end);
	
	local devour = FW:SpellName(19505);
	local spelllock = FW:SpellName(19647);
	local consume = FW:SpellName(17767);
	local seduction = FW:SpellName(6358);
	
	if CA then
		local sscast = FW:SpellName(20707);
		local summon = FW:SpellName(46546);
		local meeting = FW:SpellName(23598);
		local ritual = FW:SpellName(34143);
		
		CA:RegisterIsChannel(summon);
		
		CA:RegisterOnSelfCastStart(function(s,t)
			if s == summon then
				CA:CastShow("SummonStart",t);
			elseif s == sscast then
				CA:CastShow("SoulstoneStart",t);

			end
		end);
		CA:RegisterOnSelfCastCancel(function(s,t)
			if s == sscast then
				CA:CastShow("SoulstoneCancel",t); 
			elseif s == summon then
				CA:CastShow("SummonCancel",t);
			end
		end);
		CA:RegisterOnSelfCastSuccess(function(s,t,rank)
			if s == sscast then
				CA:CastShow("SoulstoneSuccess",t);
			elseif s == summon then
				CA:CastShow("SummonFinish",t);
			elseif s == ritual then
				CA:CastShow("SoulwellStart");
			elseif spell == seduction then
				CA:CastShow("SeduceSuccess",t);
			end
		end);
		CA:RegisterOnPetCastSuccess(function(spell)
			if spell == devour then
				CA:CastShow("DevourMagicSuccess");
			elseif spell == spelllock then
				CA:CastShow("SpellLockSuccess");
			end
		end);
		CA:RegisterOnPetCastFailed(function(spell)
			if spell == devour then
				CA:CastShow("DevourMagicFailed");
			elseif spell == spelllock then
				CA:CastShow("SpellLockFailed");
			elseif spell == seduction then
				CA:CastShow("SeduceFailed");
			end
		end);
		local function DelayedSeduceMessage()
			CA:CastShow("SeduceStart",(UnitName("pettarget")) or "?" );
		end
		CA:RegisterOnPetCastStart(function(spell)
			if spell == seduction then
				FW:DelayedExec(FW.Settings.PetTargetDelay,1,DelayedSeduceMessage);
			end
		end);
	end
	if ST then
		local fear = FW:SpellName(5782);
		local banish = FW:SpellName(710);
		local enslave = FW:SpellName(1098);

		ST:RegisterOnTimerBreak(function(unit,mark,spell)
			if spell == fear then
				if mark~=0 then unit=FW.RaidIcons[mark]..unit;end
				CA:CastShow("FearBreak",unit);
				return 1;
			elseif spell == banish then
				if mark~=0 then unit=FW.RaidIcons[mark]..unit;end
				CA:CastShow("BanishBreak",unit);
				return 1;
			elseif spell == enslave then
				if mark~=0 then unit=FW.RaidIcons[mark]..unit;end
				CA:CastShow("EnslaveBreak",unit);
				return 1;
			elseif spell == seduction then
				if mark~=0 then unit=FW.RaidIcons[mark]..unit;end
				CA:CastShow("SeduceBreak",unit);
				return 1;
			end
		end);
		ST:RegisterOnTimerFade(fear,"FearFade");
		ST:RegisterOnTimerFade(banish,"BanishFade");
		ST:RegisterOnTimerFade(enslave,"EnslaveFade");
		ST:RegisterOnTimerFade(seduction,"SeduceFade");

		local backlash = FW:SpellName(51439);
		local shadowtrance = FW:SpellName(17941);
		local decimation = FW:SpellName(63158);
		ST:RegisterOnBuffGain(function(buff)
			if buff == backlash or buff == shadowtrance or buff == decimation then
				FW:PlaySound("TimerInstantSound");
			end
		end);
	end
	if CD then
		CD:RegisterOnCooldownReady(function(spell)
			if spell == devour then
				CA:CastShow("DevourMagicReady");
			elseif spell == spelllock then
				CA:CastShow("SpellLockReady");
			end
		end);
		
		CD:AddCooldownBuff(28176); -- fel armor
		CD:AddCooldownBuff(687); -- demon armor
		
		CD:AddCooldownBuff(18789); -- burning wish
		CD:AddCooldownBuff(18792); -- fel energy
		CD:AddCooldownBuff(35701); -- touch of shadow
		CD:AddCooldownBuff(18790); -- fel stamina
		
		CD:AddHiddenCooldown(nil,34935,08); -- Backlash	
		CD:AddHiddenCooldown(nil,85113,15); -- Improved Soul Fire
		CD:AddHiddenCooldown(nil,88446,120); -- Demonic Rebirth
		
		CD:AddCasterPowerupCooldowns();
	end
	
	FW:SetMainCategory(FWL.RAID_MESSAGES);
		
		if CA then
		FW:SetSubCategory(FWL.SUMMONING,FW.ICON.SPECIFIC,2);
			FW:AddOption("MS2",2,0,FWL.SUMMON_PORTAL,		"",	"SummonFinish");
							  
		FW:SetSubCategory(FWL.SOULSTONE_NORMAL,FW.ICON.SPECIFIC,2);
			FW:AddOption("MS2",2,0,FWL.SOULTONE_START,		"",	"SoulstoneStart");
			FW:AddOption("MS2",2,0,FWL.SOULTONE_CANCEL,		"",	"SoulstoneCancel");
			FW:AddOption("MS2",2,0,FWL.SOULTONE_SUCCESS,	"",	"SoulstoneSuccess");
			FW:AddOption("MSG",2,0,FWL.SOULTONE_START_W,	"",	"SoulstoneStartWhisper");
			FW:AddOption("MSG",2,0,FWL.SOULTONE_CANCEL_W,	"",	"SoulstoneCancelWhisper");
			FW:AddOption("MSG",2,0,FWL.SOULTONE_SUCCESS_W,	"",	"SoulstoneSuccessWhisper");
			
		FW:SetSubCategory(FWL.SOULWELL,FW.ICON.SPECIFIC,2);
			FW:AddOption("MS2",2,0,FWL.SOULWELL,			"",	"SoulwellStart");
		end

		FW:SetSubCategory(FWL.PET,FW.ICON.SPECIFIC,2);
			if CA then
			FW:AddOption("MS2",2,0,FWL.SEDUCE_START,		"",	"SeduceStart");
			FW:AddOption("MS2",2,0,FWL.SEDUCE_SUCCESS,		"",	"SeduceSuccess");
			FW:AddOption("MS2",2,0,FWL.SEDUCE_FAILED,		"",	"SeduceFailed");
			end
			if ST then
			FW:AddOption("MS2",2,0,FWL.SEDUCE_BREAK,		"",	"SeduceBreak");
			FW:AddOption("MS2",2,0,FWL.SEDUCE_FADE,			"",	"SeduceFade");
			end
			if CA then
			FW:AddOption("MS2",2,0,FWL.SPELL_LOCK_SUCCESS,	"",	"SpellLockSuccess");
			FW:AddOption("MS2",2,0,FWL.SPELL_LOCK_FAILED,	"",	"SpellLockFailed");
			end
			if CD then
			FW:AddOption("MS2",2,0,FWL.SPELL_LOCK_READY,	"",	"SpellLockReady");
			end
			if CA then
			FW:AddOption("MS2",2,0,FWL.DEVOUR_MAGIC_SUCCESS,"",	"DevourMagicSuccess");
			FW:AddOption("MS2",2,0,FWL.DEVOUR_MAGIC_FAILED,	"",	"DevourMagicFailed");
			end
			if CD then
			FW:AddOption("MS2",2,0,FWL.DEVOUR_MAGIC_READY,	"",	"DevourMagicReady");
			end
		if ST then
		FW:SetSubCategory(FWL.BREAK_FADE,FW.ICON.SPECIFIC,2);
			FW:AddOption("INF",2,0,FWL.BREAK_FADE_HINT1);
			FW:AddOption("MS2",2,0,FWL.FEAR_BREAK,		"",	"FearBreak");
			FW:AddOption("MS2",2,0,FWL.FEAR_FADE,		"",	"FearFade");
			FW:AddOption("MS2",2,0,FWL.BANISH_BREAK,	"",	"BanishBreak");
			FW:AddOption("MS2",2,0,FWL.BANISH_FADE,		"",	"BanishFade");
			FW:AddOption("MS2",2,0,FWL.ENSLAVE_BREAK,	"",	"EnslaveBreak");
			FW:AddOption("MS2",2,0,FWL.ENSLAVE_FADE,	"",	"EnslaveFade");
		end
		
	if ST then
	FW:SetMainCategory(FWL.SPELL_TIMER):SetSubCategory(FWL.MY_SPELLS)
		:AddOption("CO2",1,0,FWL.CURSE,	"",				"Curse",	ST.FilterChange)
		:AddOption("CO2",1,0,FWL.BANE,	"",				"Bane",	ST.FilterChange)

	FW:SetMainCategory(FWL.SOUND):SetSubCategory(FWL.SPELL_TIMER)
		:AddOption("SND",2,0,"Instant","","TimerInstantSound")
	end

	FW:SetMainCategory(FWL.SELF_MESSAGES):SetSubCategory(FWL.BLOOD_PACT,FW.ICON.BASIC,2)
		:AddOption("MSG",1,0,FWL.BLOOD_PACT_ON,	FWL.BLOOD_PACT_TT,	"BloodPact")
		:AddOption("COL",1,0,FWL.BLOOD_PACT_GAIN,		"",		"BloodpactGainColor")
		:AddOption("COL",1,0,FWL.BLOOD_PACT_LOSS,		"",		"BloodpactLossColor")
	
	if CA then
	FW:SetMainCategory(FWL.ADVANCED):SetSubCategory(FWL.CASTING)
		:AddOption("NUM",1,0,FWL.DELAY_PET_TARGET		,"",	"PetTargetDelay",nil,0.1,1)
	end
	FW.Default.PetTargetDelay = 0.5; -- delay between pet cast start and target check

	FW.Default.SoulstoneSuccessWhisper = 	{[0]=true,">> You are now soulstoned! <<"};
	FW.Default.SoulstoneStartWhisper = 		{[0]=false,">> Soulstoning you now <<"};
	FW.Default.SoulstoneCancelWhisper = 	{[0]=false,"<< Soulstoning cancelled >>"};

	FW.Default.SummonFinish = 				{[0]=1,">> Opening Summoning Portal << Clicky clicky!"};
	FW.Default.SoulstoneSuccess = 			{[0]=0,"Soulstoned >> %s << Use it well!"};
	FW.Default.SoulstoneStart = 			{[0]=1,"Soulstoning >> %s << Now"};
	FW.Default.SoulstoneCancel = 			{[0]=1,"Soulstoning >> %s << Cancelled"};

	FW.Default.SeduceSuccess = 				{[0]=0,"Seduced >> %s << Don't hit it!"};
	FW.Default.SeduceStart = 				{[0]=0,"Seducing >> %s << Now"};
	FW.Default.SeduceFailed = 				{[0]=0,">> Seduction Failed! <<"};
	FW.Default.SeduceBreak = 				{[0]=1,">> Seduction on %s Broke Early! <<"};
	FW.Default.SeduceFade = 				{[0]=1,">> Seduction on %s Fading in 3 seconds! <<"};
	
	FW.Default.DevourMagicSuccess = 		{[0]=0,">> Devour Magic Used <<"};
	FW.Default.DevourMagicFailed = 			{[0]=0,">> Devour Magic Failed! <<"};
	FW.Default.DevourMagicReady = 			{[0]=0,">> Devour Magic ready <<"};

	FW.Default.SpellLockSuccess = 			{[0]=0,">> Spell Lock Used <<"};
	FW.Default.SpellLockFailed = 			{[0]=0,">> Spell Lock Failed! <<"};
	FW.Default.SpellLockReady = 			{[0]=0,">> Spell Lock ready <<"};
	
	FW.Default.SoulwellStart = 				{[0]=0,"Summoning >> Soulwell << Yummie!"};
	FW.Default.RitualOfDoomStart = 			{[0]=0,"Want to end it all? Clicky clicky!"};
	
	FW.Default.FearBreak = 					{[0]=0,">> Fear on %s Broke Early! <<"};
	FW.Default.FearFade = 					{[0]=0,">> Fear on %s Fading in 3 seconds! <<"};
	FW.Default.BanishBreak = 				{[0]=1,">> Banish on %s Broke Early! <<"};
	FW.Default.BanishFade = 				{[0]=1,">> Banish on %s Fading in 3 seconds! <<"};
	FW.Default.EnslaveBreak = 				{[0]=1,">> Enslave on %s Broke Early! <<"};
	FW.Default.EnslaveFade = 				{[0]=1,">> Enslave on %s Fading in 3 seconds! <<"};

	FW.Default.BloodPact = 			{[0]=false,"warrior self"};
	FW.Default.BloodpactGainColor = {1.00,0.40,0.00};
	FW.Default.BloodpactLossColor = {1.00,0.00,0.00};
	
	if CD then
		FW.InstanceDefault.Cooldown.Filter[FW:SpellName(48020)] = 		{nil,nil,{-2,0.00,0.67,0.00}}; -- Demonic Circle: Teleport
		FW.InstanceDefault.Cooldown.Filter[FW:SpellName(47541)] = 		{nil,nil,{-2,0.00,0.63,0.05}};--death coil
		FW.InstanceDefault.Cooldown.Filter[FW:SpellName(6229)] = 		{nil,nil,{-2,0.63,0.00,1.00}};--shadow ward
		FW.InstanceDefault.Cooldown.Filter[FW:SpellName(91713)] = 		{nil,nil,{-2,0.63,0.00,1.00}};--nether ward
		FW.InstanceDefault.Cooldown.Filter[FW:SpellName(29893)] = 		{nil,nil,{-2,0.64,0.21,0.93}};--ritual of souls
		FW.InstanceDefault.Cooldown.Filter[FW:SpellName(29858)] = 		{nil,nil,{-2,0.00,0.38,1.00}};--soulshatter
		FW.InstanceDefault.Cooldown.Filter[FW:SpellName(34935)] = 		{nil,nil,{-1}};--backlash
	end
end
